Bug 146037 - Autofilter is slow when filter conditions are set in multiple columns
Summary: Autofilter is slow when filter conditions are set in multiple columns
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
7.4.0.0 alpha0+ Master
Hardware: All Linux (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:7.4.0 target:7.3.0.0.beta2
Keywords: perf
Depends on:
Blocks: AutoFilter
  Show dependency treegraph
 
Reported: 2021-12-04 00:24 UTC by Kevin Suo
Modified: 2021-12-09 12:53 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Kevin Suo 2021-12-04 00:24:33 UTC
Steps to Reproduce:

1. Open attachment 176404 [details] (i.e., comment 2 in tdf#136838)

2. Click on the autofilter dropdown in column O (i.e. LC_Value), deselect the first item (i.e. -1,255,773.47), OK.
--> Fast.

3. Then click on the autofilter in column S (i.e. MaterialNumber), and deselect the first item (i.e. "(Blank)"), OK.
--> There is a 3s lag when clicking on the the autofilter dropdown. However it is still good that the filter process itself is fast.

4. Then click on the autofilter in column H (i.e. Value), and deselect the first item (i.e. "1.00"), OK.
--> There is a 3s lag when clicking on the the dropdown. Importantly, it takes a long time (around 1min) with 100% (single-core) CPU for the filter process to finish.

Version: 7.4.0.0.alpha0+ / LibreOffice Community
Build ID: ee5ed29991bf9de1111a8313d7c22560b26a56af
CPU threads: 8; OS: Linux 5.14; UI render: default; VCL: gtk3
Locale: zh-CN (zh_CN.UTF-8); UI: zh-CN
Build Platform: Fedora34@X64, Branch:master, bibisect-linux-64-7.4-CN
Calc: threaded

Fedora 34 x64 GTK3 on Wayland, 8-core CPU with 16GB RAM.
Comment 1 Kevin Suo 2021-12-04 00:27:22 UTC
Adding Luboš Luňák and Noel Grandin to CC as I think you may also be interest in this one.
Comment 2 Commit Notification 2021-12-05 09:01:51 UTC
Luboš Luňák committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/9d08f3363188d446b287c445f1ab09339c65d208

fix caching of ScQueryItem values for multiple entries (tdf#146037)

It will be available in 7.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 3 Commit Notification 2021-12-05 17:09:59 UTC
Luboš Luňák committed a patch related to this issue.
It has been pushed to "libreoffice-7-3":

https://git.libreoffice.org/core/commit/986baafc7856f43fe33a957c2faefdcd89505796

fix caching of ScQueryItem values for multiple entries (tdf#146037)

It will be available in 7.3.0.0.beta2.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.